import json, sys, getopt
from openpyxl import Workbook
from openpyxl.styles import Alignment
from itertools import cycle
#from pdb import set_trace as bp
#import pprint

def pritiPrint(x):
	print(json.dumps(x, indent=4, sort_keys=True))

def colnum_string(n):
    string = ""
    while n > 0:
        n, remainder = divmod(n - 1, 26)
        string = chr(65 + remainder) + string
    return string

def digito_verificador(rut):
    reversed_digits = map(int, reversed(str(rut)))
    factors = cycle(range(2, 8))
    s = sum(d * f for d, f in zip(reversed_digits, factors))
    s =  (-s) % 11
    if s == 10:
    	return 'k'
    else:
    	return str(s)


# Leyendo archivo
if len(sys.argv) > 1:

		try:
			opts, args = getopt.getopt(sys.argv[1:],"f:")
			nombre_archivo = sys.argv[2]

		except getopt.GetoptError:
			print('La forma correcta es: notas -f <archivo>')
			sys.exit(2)
		
		if len(sys.argv) > 3:
			print('La forma correcta es: notas -f <archivo>')
			sys.exit(2)


# Leyendo datos
with open(nombre_archivo, 'r') as f:
    distros_dict = json.load(f)
#pp = pprint.PrettyPrinter(indent=4)

pregs_control = []

ppl = []
name = distros_dict['nombre'] +'_id_'+ distros_dict['id']
resps = distros_dict['respuestas']

for r in resps:
	salir = 0
	#pritiPrint(distros_dict['respuestas'][r])
	resps_person = distros_dict['respuestas'][r]['respuestas']
	person_c = ['nodata'] * 15
	pages = []
	for p in resps_person:
		pages.append(resps_person[p])
	pages = [j for sub in pages for j in sub]
	for p in pages:
		if p['tipo'] == 'instruccion':
			pages.pop(pages.index(p))
	#print(r)
	#pp.pprint(pages)
	for i in range(len(pages)):	
		try:
			catt = pages[i]['categoria']
			person_c[i] = pages[i]['categoria'] + '_' + pages[i]['tipo']
			if person_c[i] not in pregs_control:
				pregs_control.append(person_c[i])
		except:
			salir = 1
	if salir:
		continue

for r in resps:

	#pritiPrint(distros_dict['respuestas'][r])
	resps_person = distros_dict['respuestas'][r]['respuestas']
	person_s = [-1.0] * 15
	person_c = ['nodata'] * 15
	person_r = [''] * 15
	person = r
	pages = []
	salir = 0
	for p in resps_person:
		pages.append(resps_person[p])

	pages = [j for sub in pages for j in sub]

	for p in pages:
		if p['tipo'] == 'instruccion':
			pages.pop(pages.index(p))

	for i in range(len(pages)):
		try:
			catt = pages[i]['categoria']
			ptje = pages[i]['puntaje']
			person_s[i] = int(pages[i]['puntaje']) / int(pages[i]['puntaje_max'])
			person_c[i] = pages[i]['categoria'] + '_' + pages[i]['tipo']
			if isinstance(pages[i]['respuesta'],list):
				person_r[i] = ', '.join(pages[i]['respuesta'])
			else:
				person_r[i] =  pages[i]['respuesta'].replace('<p>','').replace('</p>','').replace('&nbsp;','')
		except:
			#print("Unexpected error:", sys.exc_info()[0])
			#raise
			salir = 1
	if salir:
		continue

	#caso omitadas
	if 'nodata' in person_c:
		pregs_control_person = pregs_control
		for i in range(len(person_c)):
			if person_c[i] in pregs_control_person:
				pregs_control_person.remove(person_c[i])
		for i in range(len(person_c)):
			if person_c[i] == 'nodata':
				person_c[i] = pregs_control_person[0]
				pregs_control_person.pop(0)


	big_person = {}
	big_person['rut'] = person + '-' + digito_verificador(person)
	big_person['score'] = person_s
	big_person['pregs'] = person_c
	big_person['resps'] = person_r

	ppl.append(big_person)

#pp = pprint.PrettyPrinter(indent=4)
#pp.pprint(ppl)

#bp()
# Creando el excel

wb = Workbook()
align = Alignment(horizontal='center',vertical='center')
dest_filename = name + '.xlsx'
ws1 = wb.active
ws1.title = "Datos"
#print(ppl)
cats = ppl[0]['pregs']
ws1.column_dimensions['A'].width = 11
header_index = [None] * len(cats)
for i in range(len(cats)):
	ws1[colnum_string(i+2)+'1'] = cats[i]
	ws1[colnum_string(i+2)+'1'].alignment = align
	ws1.column_dimensions[colnum_string(i+2)].width = 18
	header_index[i] = cats[i]

for i in range(len(ppl)):
	ws1['A'+str(i+2)] = ppl[i]['rut']
	#print(ppl[i]['rut'])
	for j in range(len(ppl[i]['pregs'])):
		hindex = header_index.index(ppl[i]['pregs'][j])
		#print(hindex)
		value = ppl[i]['score'][j]
		ws1[colnum_string(hindex+2)+str(i+2)] = value

ws2 = wb.create_sheet("Respuestas")
ws2.title = 'Respuestas'

cats = ppl[0]['pregs']
ws1.column_dimensions['A'].width = 11
header_index = [None] * len(cats)
for i in range(len(cats)):
	ws2[colnum_string(i+2)+'1'] = cats[i]
	ws2[colnum_string(i+2)+'1'].alignment = align
	ws2.column_dimensions[colnum_string(i+2)].width = 18
	header_index[i] = cats[i]

for i in range(len(ppl)):
	ws2['A'+str(i+2)] = ppl[i]['rut']
	for j in range(len(ppl[i]['pregs'])):
		hindex = header_index.index(ppl[i]['pregs'][j])
		value = ppl[i]['resps'][j]
		ws2[colnum_string(hindex+2)+str(i+2)] = value

wb.save(filename = dest_filename)
#print(dest_filename+' terminado.')